%error = ForceRequiredAddOn("Brick_Treasure_Chest");

if(%error == $Error::AddOn_Disabled)
{
	brickTreasureChestOpenData.uiName = "";
	brickTreasureChestData.uiName = "";
}

if(%error == $Error::AddOn_NotFound)
{
	error("ERROR: Event_onChestOpen - required add-on Brick_Treasure_Chest not found");

	return;
}

registerInputEvent("fxDTSBrick", "onChestOpen", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");

package onChestOpen
{
	function fxDTSBrick::onActivate(%obj, %player, %client, %pos, %vec)
	{  
		%data = %obj.getDataBlock();

		if(%data.getID() == brickTreasureChestData.getID())
		{
			%hash = sha1(%obj.getPosition() @ %obj.angleID);

			if(!%client.foundTreasureChest_[%hash])
			{
				$InputTarget_["Self"] = %obj;
				$InputTarget_["Player"] = %player;
				$InputTarget_["Client"] = %client;

				if($Server::LAN)
				{
					$InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
				}

				else
				{
					if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%client))
					{
						$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
					}

					else
					{
						$InputTarget_["MiniGame"] = 0;
					}
				}

				%obj.processInputEvent(onChestOpen, %client);

				%obj.openTreasureChest(%player);
			}

			else
			{
				parent::onActivate(%obj, %player, %client, %pos, %vec);

				%obj.processInputEvent(onActivate, %client);
			}
		}

		else if(%data.getID() == brickTreasureChestOpenData.getID())
		{
			//don't do on activate events
		}

		else
		{
			parent::onActivate(%obj, %player, %client, %pos, %vec);
		}
	}

	function brickTreasureChestData::onPlant(%data, %obj)
	{
		parent::onPlant(%data, %obj);

		%obj.clearEvents();

		%enabled     = 1;
		%delay       = 0;
		%inputEvent  = "onChestOpen";
		%target      = "Client";
		%outputEvent = "PlaySound";
		%par1        = rewardSound.getId();
		%obj.addEvent(%enabled, %delay, %inputEvent, %target, %outputEvent, %par1);
	}
};
activatePackage(onChestOpen);